<?php

namespace HCM\FPA\Services;

use HCM\FPA\Repository\RelatCustomSituFuncRepository;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class RelatCustomSituFuncService {

    /**
     * @var relatCustomSituFuncRepository
     */
    protected $relatCustomAdmissaoRepository;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, RelatCustomSituFuncRepository $relatCustomSituFuncRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->relatCustomSituFuncRepository = $relatCustomSituFuncRepository;
    }

    /**
     * @return array
     */

    public function getRelatCustomSituFunc($filters) {
        
        $parameters = array(
            'P_NRORG'          => '',
            //'P_NRORG_PADRAO'   => '',
            'P_DTMESCOMPETENC' => '',
            'P_NRESTRUTLEGAL'  => '',
            'P_NRESTRUTGEREN'  => '',
            'P_NRVINCULO'      => '',
            'P_DTINICIO'       => '',
            'P_DTFINAL'        => '',
            'P_DIASLIMITE'     => '15',
            'P_NROCORRECAL'    => $this->hcmParameters->getNrOcorrenciaCalculo(),
            'P_NRTPMODALIDCAL' => $this->hcmParameters->getTipoModalidadeCalculo()
            );
            
        foreach ($filters as $filter) {
            switch($filter['columnName']){
                case 'P_NRORG':          $parameters['P_NRORG']          = $filter['value']; break;
                //case 'P_NRORG_PADRAO':   $parameters['P_NRORG_PADRAO']   = $filter['value']; break;
                case 'P_DTMESCOMPETENC': $parameters['P_DTMESCOMPETENC'] = $filter['value']; break;
                case 'NRESTRUTLEGAL':    $parameters['P_NRESTRUTLEGAL']  = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                case 'NRESTRUTGEREN':    $parameters['P_NRESTRUTGEREN']  = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                case 'NRVINCULOM':       $parameters['P_NRVINCULO']      = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                case 'DTINICIO':         $parameters['P_DTINICIO']       = $filter['value']; break;
                case 'DTFINAL':          $parameters['P_DTFINAL']        = $filter['value']; break;
                case 'QDEDIASLIMITE':    $parameters['P_DIASLIMITE']     = $filter['value']; break;
            }
        }
        
        set_time_limit(0);
        ini_set('memory_limit', '2048M');

        return $this->relatCustomSituFuncRepository->getRelatCustomSituFunc($parameters);
    }
    

} 