<?php
namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Geral\Logic\ImportacaoXSD;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\HTTP\Kernel;

class EsoEventoService {
    
    private $arrRegistros = array();

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, Kernel $httpKernel) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->httpKernel = $httpKernel;
    }

    public function importacaoXSD($nrorg, $nrevento, $dspath) {
        try {
            $this->arrRegistros = array();
            
            $nmarquivo = $dspath[0]['name'];
            
            $arquivo = $dspath[0];
            $file = $this->httpKernel->factoryFromFileData($arquivo, FPA::getTempDirectory()."/");
            
            if (!$file->isFile()) {
                throw new \Exception("Falha ao gravar o arquivo.", 1);
            }
            
            $importacaoXSD = new ImportacaoXSD($this->entityManager, $this->hcmParameters);
            $importacaoXSD->importarXSD($nrevento, $file);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}