<?php

namespace HCM\Util;

class FileUploader {
    
    /**
     * CALL /Zeedhi/Framework/Remote/FileUploader/Server.php
     * 
     * Upload files in rows and replace the property to the file data with server path.
     *
     * @param array|\ArrayAccess $row           The row where files are stored.
     * @param string             $fileFieldName The name of column row to be uploaded.
     * @param string             $customFolder  The folder where files should be stored.
     *
     * @throws Exception
     */
    
    public static function uploadFilesInRow(&$row, $fileFieldName, $customFolder = "") {
        $instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();
        
        $zhFileUploader = $instanceManager->getService('zhFileUploader');
        
        return $zhFileUploader->uploadFilesInRow($row, $fileFieldName, $customFolder);
    }
    
    /**
     * Delete a previously uploaded file.
     *
     * @param string $path The file path of file to be excluded.
     *
     * @throws Exception
     */
    public static function deleteFile($path) {
        var_dump("aqui");die;
        $instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();
        
        $zhFileUploader = $instanceManager->getService('zhFileUploader');
        
        return $zhFileUploader->deleteFile($path);
    }

}
