<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 15/07/14
 * Time: 17:01
 */

namespace Importacao\Logic\Integracao\Mastermaq;

use \Importacao\Logic\Integracao\Mastermaq\Classes\GeraEvento;
use \Importacao\Logic\Integracao\Mastermaq\Classes\GeraEstrutura;
use \Importacao\Logic\Integracao\Mastermaq\Classes\GeraEstruturaSindicato;
use \Importacao\Logic\Integracao\Mastermaq\Classes\GeraEscalaTrabalho;


class IntegraCompleto {

    private $destino;
    private $origem;
    private $tab_EV_TEMP;
    private $tab_CLIENTES;
    private $tab_SINDI;
    private $tab_QD_HORAR;

    /**
     * @param $destino          -- Endereço de onde será salvo os arquivos XLS
     * @param $origem           -- Endereço onde será encontrado os arquivos DBF
     * @param $tabelas
     */
    function __construct($destino, $origem, $tabelas)
    {
        $this->destino = $destino;
        $this->origem = $origem;
        $this->tab_CLIENTES = $tabelas['CLIENTES'];
        $this->tab_EV_TEMP = $tabelas['EV_TEMP'];
        $this->tab_QD_HORAR = $tabelas['QD_HORAR'];
        $this->tab_SINDI = $tabelas['SINDI'];
    }


    private function geraEvento()
    {
        $ocupacao = new GeraEvento($this->tab_EV_TEMP);
        $ocupacao->getInfo();
        $ocupacao->gerarXls($this->destino);
    }

    private function geraEstrutura()
    {
        $estrutura = new GeraEstrutura($this->tab_CLIENTES);
        $estrutura->getInfo();

        $estrutura->connect($this->tab_SINDI);
        $estrutura->getInfo();
        
        $estrutura->gerarXls($this->destino);
    }

    private function geraEscalaTrabalho()
    {
        $ocupacao = new GeraEscalaTrabalho($this->tab_QD_HORAR);
        $ocupacao->getInfo();
        $ocupacao->gerarXls($this->destino);
    }

    public function gerar()
    {
        if(!empty($this->tab_EV_TEMP)){
            $this->geraEvento();
        }
        if(!empty($this->tab_CLIENTES) && !empty($this->tab_SINDI)){
            $this->geraEstrutura();
        }
        if(!empty($this->tab_QD_HORAR)){
            $this->geraEscalaTrabalho();
        }
    }
} 