<?php
namespace Planejamento\Repositories;

class Confcard extends \Doctrine\ORM\EntityRepository
{
    public function contaNumeroDeTipoDeCardapiosNaPagina($nrorg, $filial, $servico, $maxPagina){
        $sql = "select count(NRPAGCNFCARD) as MAXTIPOPRATO
                    from confcard
                    where NRPAGCNFCARD = $maxPagina and
                    nrorg= '$nrorg' and
                    cdfilial = '$filial' and
                    cdservfili = '$servico'";
        $resultado = $this->getEntityManager()->getConnection()->fetchAll($sql);
        return $resultado[0]['MAXTIPOPRATO'];
    }

    /**
     * Exclui configuração padrão
     *
     * @param String $cdfiliorig    Unidade de origem
     * @param String $cdservorig    Serviço de origem
     * @param String $listafiliserv Lista de unidade e serviço
     *
     * @return \Doctrine\DBAL\Driver\Statement
     * @throws \Exception
     */
    public function exportaConfiguracaoPadrao(
        $cdfiliorig, $cdservorig, $listafiliserv
    ) {
        try {
            $sql
                = "INSERT
                   INTO CONFCARD
                   (CDFILIAL, CDSERVFILI, NRSEQCNFCARD, CDTIPOPRAT, IDOPCCNFCARD,
                   IDIMPCNFCARD, NRPAGCNFCARD, VRPERCOMCARD, NRORDCNFCARD, DTULTATUCFCA,
                   DSOBSCNFCARD, DSCOMPLTP, IDTPPRATEXTR, IDVISUTPEXTR, IDTPPRATSEGP,
                   IDTPPRATTERP, IDTPPRATQUAP, IDTPPRATQUIP, IDTPPRATSEXP, IDTPPRATSABP,
                   IDTPPRATDOMP, IDTPPRATFERP, IDCONCNFCARD, CDCONTAINER, NRGRUPOEMB)
                   (SELECT SE.CDFILIAL, SE.CDSERVFILI, NRSEQCNFCARD, CDTIPOPRAT,
                          IDOPCCNFCARD, IDIMPCNFCARD, NRPAGCNFCARD, VRPERCOMCARD,
                          NRORDCNFCARD, DTULTATUCFCA, DSOBSCNFCARD, DSCOMPLTP,
                          IDTPPRATEXTR, IDVISUTPEXTR, IDTPPRATSEGP, IDTPPRATTERP,
                          IDTPPRATQUAP, IDTPPRATQUIP, IDTPPRATSEXP, IDTPPRATSABP,
                          IDTPPRATDOMP, IDTPPRATFERP, IDCONCNFCARD,
                          CDCONTAINER, NRGRUPOEMB
                       FROM CONFCARD CF,
                            SERVICO SE
                       WHERE (CF.CDFILIAL = :P_CDFILIORIG)
                       AND (CF.CDSERVFILI = :P_CDSERVORIG)
                       AND ((INSTR(:P_LISTAFILISERV,SE.CDFILIAL || SE.CDSERVFILI)  <> 0)
                       OR (:P_LISTAFILISERV = 'T'))
                       AND SE.CDFILIAL || SE.CDSERVFILI <> :P_CDFILIORIG || :P_CDSERVORIG)";
            $params = array(
                'P_CDFILIORIG' => $cdfiliorig,
                'P_CDSERVORIG' => $cdservorig,
                'P_LISTAFILISERV' => $listafiliserv,
            );
            return $this->_em->getConnection()->executeQuery($sql, $params);
//            $conn = \Setforms2\Runtime\Connection::getInstance();
//            return $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Exclui configuração padrão
     *
     * @param String $cdfiliorig    Unidade de origem
     * @param String $cdservorig    Serviço de origem
     * @param String $listafiliserv Lista de unidade e serviço
     *
     * @return \Doctrine\DBAL\Driver\Statement
     * @throws \Exception
     */
    public function excluiConfiguracaoPadrao(
        $cdfiliorig, $cdservorig, $listafiliserv
    ) {
        try {
            $sql
                = "DELETE
                    FROM CONFCARD
                    WHERE ((INSTR(:P_LISTAFILISERV, CDFILIAL || CDSERVFILI) <> 0)
                    OR (:P_LISTAFILISERV = 'T'))
                    AND CDFILIAL || CDSERVFILI <> :P_CDFILIORIG || :P_CDSERVORIG";
            $params = array(
                'P_LISTAFILISERV' => $listafiliserv,
                'P_CDFILIORIG' => $cdfiliorig,
                'P_CDSERVORIG' => $cdservorig,
            );

            return $this->_em->getConnection()->executeQuery($sql, $params);
//            $conn = \Setforms2\Runtime\Connection::getInstance();
//            return $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function BuscaConfiguracaoPadraUnidade($cdfilial, $cdservfili){
        $sql = <<<SQL
        SELECT CDTIPOPRAT FROM CONFCARD WHERE CDFILIAL = :CDFILIAL AND CDSERVFILI =:CDSERVFILI
SQL;
        $params = array(
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI' =>$cdservfili);
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function BuscaSequenciaTipoPrato($cdfilial, $cdservfili, $cdtipoprat){
        $sql = <<<SQL
SELECT NRSEQCNFCARD
FROM CONFCARD
WHERE CDFILIAL=:CDFILIAL
AND CDSERVFILI=:CDSERVFILI
AND CDTIPOPRAT=:CDTIPOPRAT
SQL;
        $params = array(
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI' =>$cdservfili,
            'CDTIPOPRAT' =>$cdtipoprat);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function RetornaCdTipoPrato($cdfilial, $cdservfili, $cdtipoprat){
        $sql = <<<SQL
SELECT CDTIPOPRAT FROM CONFCARD
WHERE CDFILIAL =:CDFILIAL AND
CDSERVFILI=:CDSERVFILI AND
 CDTIPOPRAT=:CDTIPOPRAT
SQL;
        $params = array(
            'CDFILIAL' => $cdfilial,
            'CDSERVFILI' => $cdservfili,
            'CDTIPOPRAT' => $cdtipoprat,
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }



    public static function BuscaConfcard($cdfilial, $cdservfili, $nrseqprat){
        $sql = <<<SQL
SELECT NRSEQCNFCARD FROM CONFCARD WHERE
CDFILIAL = :CDFILIAL AND
CDSERVFILI = :CDSERVFILI AND
NRSEQCNFCARD = :NRSEQCNFCARD AND
NRORG = :NRORG
SQL;
        $params = array(
            'CDFILIAL' => $cdfilial,
            'CDSERVFILI' => $cdservfili,
            'NRSEQCNFCARD' => $nrseqprat

        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }


    public static function BuscaConfiguracao($cdfilial, $cdservfili, $nrseqcnfcard){
        $sql= <<<SQL
        SELECT CDFILIAL, CDSERVFILI, NRSEQCNFCARD, CDTIPOPRAT FROM CONFCARD WHERE
CDFILIAL= :CDFILIAL AND
CDSERVFILI = :CDSERVFILI AND
NRSEQCNFCARD = :NRSEQCNFCARD
SQL;

     $params = array(
            'CDFILIAL'=>$cdfilial,
            'CDSERVFILI'=>$cdservfili,
            'NRSEQCNFCARD'=>$nrseqcnfcard
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }


}