<?php
/**
 * RegistroZCAGED vers?o ACI 4.00
 *
 * @package    Logic
 * @subpackage Registro/Caged
 *
 * @author     brunofeliciano - 27/06/2011
 *
 */
class RegistroZCAGED extends RegistroCAGED{

    const REGISTRO_Z = 'Z';

    private $_estrutura;


    /**
     * Gera Tipo de Registro Z.
     *
     * @param EstruturamEntity $estrutura   Instancia de EstruturamEntity.
     * @param string           $tpInscricao Numero do tipo de inscricao.
     * @param string           $nrInscricao Numero da inscricao.
     *
     * @return void
     *
     * @author brunofeliciano - 27/06/2011
     */
    public function geraRegistroZ(EstruturamEntity $estrutura, $tpInscricao, $nrInscricao){
        $this->_estrutura = $estrutura;
        $this->_geraRegistro(self::REGISTRO_Z, $tpInscricao, $nrInscricao);
    }


    /**
     * Atribui os dados no atributo da classe Pai.
     *
     * @param string $tpRegistro  Numero do tipo do registtro.
     * @param string $tpInscricao Numero do tipo de inscricao (Sem necessidade para este registro).
     * @param string $nrInscricao Numero da inscricao (Sem necessidade para este registro).
     *
     * @return void
     *
     * @author brunofeliciano - 27/06/2011
     *         leonardocarvalho - 07/04/2015
     */
    private function _geraRegistro($tpRegistro, $tpInscricao, $nrInscricao){

        // Bloco 1 | 001 | Tipo do Registro.
        $this->atribuiDado($tpRegistro, 1);

        // Bloco 2 | 002-041 | Nome.
        $this->atribuiDado('RAIMUNDO SANDI PENA', 40, parent::CARACTER_BRANCO, parent::PREENCHE_DIREITA);

        // Bloco 3 | 042-091 | E-mail.
        $this->atribuiDado('folha@teknisa.com', 50, parent::CARACTER_BRANCO, parent::PREENCHE_DIREITA);

        // Bloco 4 | 092-98 | ? (Zeros).
        $this->atribuiDado('', 7, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);

        // Bloco 5 | 099-109 | CPF.
        $this->atribuiDado('95490566604', 11, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);

        // Bloco 6 | 110-231 | ? (Brancos).
        $this->atribuiDado('', 122, parent::CARACTER_BRANCO, parent::PREENCHE_DIREITA);

        // Bloco 7 | 232-240 | ?.
        $this->atribuiDado('', 9, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);

    }


}