<?php

/**
 * Itemsoli
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Itemsoli extends DaoItemsoli
{


    public static function updateStatusPorSolicitacao($cdfilsoli, $cdfillanca, $nrsolicmp ,$nrorg, $status){
        $db = self::getConnection();
        $sql = "
            UPDATE ITEMSOLI SET IDSOLIAPROV = :STATUS
            WHERE CDFILSOLI = :CDFILDOLI AND
            CDFILLAN = :CDFILLAN         AND
            NRSOLICMP = :NRSOLICMP       AND
            NRORG = :NRORG
        ";
        $db->exec($sql, array($status, $cdfilsoli, $cdfillanca, $nrsolicmp ,$nrorg));
    }


    public static function updateStatusPorProduto($cdfilsoli, $cdfillanca, $nrsolicmp ,$nrorg, $cdproduto, $dtentrega, $status){
        $db = self::getConnection();
        $sql = "
            UPDATE ITEMSOLI SET IDSOLIAPROV = :STATUS
            WHERE CDFILSOLI = :CDFILDOLI AND
            CDFILLAN = :CDFILLAN         AND
            NRSOLICMP = :NRSOLICMP       AND
            NRORG = :NRORG               AND
            CDPRODUTO = :CDPRODUTO       AND
            DTPROGENTR = :DTPROGENTR
        ";
        $db->exec($sql, array($status, $cdfilsoli, $cdfillanca, $nrsolicmp ,$nrorg, $cdproduto, $dtentrega));
    }


    public static function updateItemSolicitacaoCrossTab($cdfilsoli, $cdfillanca, $nrsolicmp ,$nrorg, $cdproduto, $dtentrega, $qtsoliprod){
        $db = self::getConnection();
            $sql = "
                UPDATE ITEMSOLI SET CDPRODUTO = :CDPRODUTO,
                DTPROGENTR = :DTPROGENTR, QTSOLIPROD = :QTSOLIPROD
                WHERE CDFILSOLI = :CDFILSOLI AND
                CDFILLAN = :CDFILLAN         AND
                NRSOLICMP = :NRSOLICMP       AND
                NRORG = :NRORG               AND
                CDPRODUTO = :CDPRODUTO       AND
                TO_CHAR(DTPROGENTR, 'DD/MM/YYYY') = :DTPROGENTR
            ";
            $db->exec($sql, array( $cdproduto, $dtentrega, $qtsoliprod, $cdfilsoli, $cdfillanca, $nrsolicmp ,$nrorg, $cdproduto, $dtentrega));
    }


    public static function importaSolicitacao($params){
        $db = self::getConnection();
        $sql = "
                INSERT
                INTO ITEMSOLI
                  (
                    CDFILSOLI,
                    CDFILLAN,
                    NRSOLICMP,
                    CDPRODUTO,
                    DTPROGENTR,
                    QTSOLIPROD,
                    IDITMSOLEXTRA,
                    NRORG,
                    DTINCLUSAO,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO
                  )
                  (SELECT DISTINCT
                      :CDFILSOLI,
                      :CDFILLAN,
                      :NRSOLICMP,
                      CDPRODUTO,
                      :DTPROGENTR,
                      :QTSOLIPROD,
                      :IDITMSOLEXTRA,
                      :NRORG,
                      :DTINCLUSAO,
                      :NRORGINCLUSAO,
                      :CDOPERINCLUSAO
                    FROM ITEMSOLI
                    WHERE (NRORG       = :NRORG)
                    AND (NRSOLICMP     = :NRSOLICMPIMP)
                    AND (CDFILSOLI     = :CDFILSOLIIMP)
                    AND (CDFILLAN      = :CDFILLANIMP)
                    AND CDPRODUTO NOT IN
                      (SELECT CDPRODUTO
                      FROM ITEMSOLI
                      WHERE (NRORG    = :NRORG)
                      AND (NRSOLICMP  = :NRSOLICMP)
                      AND (CDFILSOLI  = :CDFILSOLI)
                      AND (CDFILLAN   = :CDFILLAN)
                      AND (DTPROGENTR = :DTPROGENTR)
                      )
                  )
        ";
        $db->execute($sql, array(
                $params['CDFILSOL'],
                $params['CDFILLANC'],
                $params['NRSOLICMP'],
                $params['DTPROGENTR'],
                $params['QTSOLIPROD'],
                $params['IDITMSOLEXTRA'],
                $params['NRORG'],
                $params['DTINCLUSAO'],
                $params['NRORG'],
                $params['CDOPERINCLUSAO'],
                $params['NRORG'],
                $params['NRSOLICMPIMP'],
                $params['CDFILSOLIMP'],
                $params['CDFILLANCIMP'],
                $params['NRORG'],
                $params['NRSOLICMP'],
                $params['CDFILSOL'],
                $params['CDFILLANC'],
                $params['DTPROGENTR'],
            )
        );

    }


    public static function deletaListaProdutos($params){
        $db = self::getConnection();
        $sql = "
                DELETE
                FROM ITEMSOLI
                WHERE CDFILLAN = :CDFILLANCA
                AND CDFILSOLI  = :CDFILSOLI
                AND NRSOLICMP  = :NRSOLICMP
                AND CDPRODUTO BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN
        ";
        $db->execute($sql,
            array(
                $params['CDFILLANC'],
                $params['CDFILSOLI'],
                $params['NRSOLICMP'],
                $params['CDPRODINI'],
                $params['CDPRODFIN'],
            )
        );
    }


    public static function gravaListaProdutos($params){
        $db = self::getConnection();
        $sql = "
            INSERT
            INTO ITEMSOLI
              (
                CDFILSOLI,
                CDFILLAN,
                NRSOLICMP,
                CDPRODUTO,
                DTPROGENTR,
                QTSOLIPROD,
                IDITMSOLEXTRA,
                NRORG,
                DTINCLUSAO,
                NRORGINCLUSAO,
                CDOPERINCLUSAO
              )
              (SELECT :CDFILSOLI,
                  :CDFILLAN,
                  :NRSOLICMP,
                  CDPRODUTO,
                  :DTPROGENTR,
                  :QTSOLIPROD,
                  :IDITMSOLEXTRA,
                  :NRORG,
                  :DTINCLUSAO,
                  :NRORGINCLUSAO,
                  :CDOPERINCLUSAO
              FROM PRODUTO
                WHERE (CDPRODUTO BETWEEN :PRODINI AND :PRODFIN) ";
        if ($params['PRODUTOCOMPRA'] === 'N') {
            $sql .= " AND (CDPRODUTO = CDPRODESTO)";
        }
        $sql .= "
            AND (CDNVPRODUTO = :NVPROD)
            AND CDPRODUTO NOT IN
              (SELECT CDPRODUTO
              FROM ITEMSOLI
              WHERE (NRORG    = :NRORG)
              AND (NRSOLICMP  = :NRSOLICMP)
              AND (CDFILSOLI  = :CDFILSOLI)
              AND (CDFILLAN   = :CDFILLAN)
              AND (DTPROGENTR = :DTPROGENTR)
              AND (CDPRODUTO BETWEEN :PRODINI AND :PRODFIN)
            )
          )
        ";

        $parametros = array(
            $params['CDFILSOLI'],
            $params['CDFILLANC'],
            $params['NRSOLICMP'],
            $params['DTPROGENTR'],
            $params['QTSOLIPROD'],
            $params['IDITMSOLEXTRA'],
            $params['NRORG'],
            $params['DTINCLUSAO'],
            $params['NRORG'],
            $params['CDOPERINCLUSAO'],
            $params['CDPRODINI'],
            $params['CDPRODFIN'],
            $params['NVPROD'],
            $params['NRORG'],
            $params['NRSOLICMP'],
            $params['CDFILSOLI'],
            $params['CDFILLANC'],
            $params['DTPROGENTR'],
            $params['CDPRODINI'],
            $params['CDPRODFIN'],
        );
        return $db->execute($sql, $parametros);
    }


}