/*
  Tabela ENDEFILI: Endereo da Filial.
  Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes nas colunas que se encontram
             na tabela ENDEFILI.
  Objetivo: Gerar um log que vai utilizar a tabela Geral de Logs de Operaes para registrar as alteraes
            nas colunas da tabela ENDEFILI.
*/

CREATE OR REPLACE TRIGGER LOG_GER_ENDEFILI
AFTER UPDATE OR INSERT OR DELETE
ON ENDEFILI FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_DSTPENDEFORN VARCHAR2(20);
  V_DSTPENDEFILI VARCHAR2(20);
  
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_TIPO       := '0';
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFilial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.IDTPENDEFILI IS NOT NULL THEN
         IF :OLD.IDTPENDEFILI = 'P' THEN
            V_DSTPENDEFILI := '-Principal';
         ELSE
            IF :OLD.IDTPENDEFILI = 'C' THEN
               V_DSTPENDEFILI := '-Cobrana';
            ELSE
               IF :OLD.IDTPENDEFILI = 'E' THEN
                  V_DSTPENDEFILI := '-Exterior';
               ELSE
                  IF :OLD.IDTPENDEFILI = 'X' THEN
                     V_DSTPENDEFILI := '-Exportao';
                  END IF;
               END IF;
            END IF;
         END IF;
         V_DESC := V_DESC||' TipoEnde='||:OLD.IDTPENDEFILI||V_DSTPENDEFILI;
      END IF;

      IF :OLD.DSENDEFILISEP IS NOT NULL THEN
         V_DESC := V_DESC || ' DescEndereo=' || :OLD.DSENDEFILISEP;
      END IF;

      IF :OLD.NRENDEFILISEP IS NOT NULL THEN
         V_DESC := V_DESC || ' Nmero=' || :OLD.NRENDEFILISEP;
      END IF;

      IF :OLD.DSCOMPENDFIL	IS NOT NULL THEN
         V_DESC := V_DESC || ' Complemento=' || :OLD.DSCOMPENDFIL;
      END IF;

      IF :OLD.CDLOGRADOURO	IS NOT NULL THEN
         V_DESC := V_DESC || ' Logradouro=' || :OLD.CDLOGRADOURO;
      END IF;

      IF :OLD.CDPAIS	IS NOT NULL THEN
         V_DESC := V_DESC || ' Pas=' || :OLD.CDPAIS;
      END IF;

      IF :OLD.SGESTADO IS NOT NULL THEN
         V_DESC := V_DESC || ' SgEstado=' || :OLD.SGESTADO;
      END IF;

      IF :OLD.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdMunicpio=' || :OLD.CDMUNICIPIO;
      END IF;

      IF :OLD.NRCEPFILI	IS NOT NULL THEN
         V_DESC := V_DESC || ' Cep=' || :OLD.NRCEPFILI;
      END IF;

      IF :OLD.NMCONTFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' Contato=' || :OLD.NMCONTFILI;
      END IF;

      IF :OLD.DSEMAILFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' Email=' || :OLD.DSEMAILFILI;
      END IF;

      IF :OLD.NRDDDFAXFILI	IS NOT NULL THEN
         V_DESC := V_DESC || ' DDDFax=' || :OLD.NRDDDFAXFILI;
      END IF;

      IF :OLD.NRFAXFILISEP	IS NOT NULL THEN
         V_DESC := V_DESC || ' TelFax=' || :OLD.NRFAXFILISEP;
      END IF;

      IF :OLD.NRRAMALFAXFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' RamalFax=' || :OLD.NRRAMALFAXFILI;
      END IF;

      IF :OLD.NRDDDTELEFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' DDDTel1=' || :OLD.NRDDDTELEFILI;
      END IF;

      IF :OLD.NRTELEFILISEP IS NOT NULL THEN
         V_DESC := V_DESC || ' Tel1=' || :OLD.NRTELEFILISEP;
      END IF;

      IF :OLD.NRRAMALFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' RamalTel=' || :OLD.NRRAMALFILI;
      END IF;

      IF :OLD.NRDDDTELEXFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' DDDTel2=' || :OLD.NRDDDTELEXFILI;
      END IF;

      IF :OLD.NRTELEXFILISEP IS NOT NULL THEN
         V_DESC := V_DESC || ' Tel2=' || :OLD.NRTELEXFILISEP;
      END IF;

      IF :OLD.NRRAMTELEXFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' RamalTel2=' || :OLD.NRRAMTELEXFILI;
      END IF;

      IF :OLD.DSEMAILEMXMLNFE	IS NOT NULL THEN
         V_DESC := V_DESC || ' EmailNFe=' || :OLD.DSEMAILEMXMLNFE;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDFILIAL,'!') <> NVL(:NEW.CDFILIAL,'!'))      OR
            (NVL(:OLD.IDTPENDEFILI,'!') <> NVL(:NEW.IDTPENDEFILI,'!')) OR
            (NVL(:OLD.DSENDEFILISEP,'!') <> NVL(:NEW.DSENDEFILISEP,'!')) OR
            (NVL(:OLD.NRENDEFILISEP,'!') <> NVL(:NEW.NRENDEFILISEP,'!')) OR
            (NVL(:OLD.DSCOMPENDFIL,'!') <> NVL(:NEW.DSCOMPENDFIL,'!')) OR
            (NVL(:OLD.CDLOGRADOURO,'!') <> NVL(:NEW.CDLOGRADOURO,'!')) OR
            (NVL(:OLD.CDPAIS,'!') <> NVL(:NEW.CDPAIS,'!')) OR
            (NVL(:OLD.SGESTADO,'!') <> NVL(:NEW.SGESTADO,'!')) OR
            (NVL(:OLD.CDMUNICIPIO,'!') <> NVL(:NEW.CDMUNICIPIO,'!')) OR
            (NVL(:OLD.NRCEPFILI,'!') <> NVL(:NEW.NRCEPFILI,'!')) OR
            (NVL(:OLD.NMCONTFILI,'!') <> NVL(:NEW.NMCONTFILI,'!')) OR
            (NVL(:OLD.DSEMAILFILI,'!') <> NVL(:NEW.DSEMAILFILI,'!')) OR
            (NVL(:OLD.NRDDDFAXFILI,'!') <> NVL(:NEW.NRDDDFAXFILI,'!')) OR
            (NVL(:OLD.NRFAXFILISEP,'!') <> NVL(:NEW.NRFAXFILISEP,'!')) OR
            (NVL(:OLD.NRRAMALFAXFILI,'!') <> NVL(:NEW.NRRAMALFAXFILI,'!')) OR
            (NVL(:OLD.NRDDDTELEFILI,'!') <> NVL(:NEW.NRDDDTELEFILI,'!')) OR
            (NVL(:OLD.NRTELEFILISEP,'!') <> NVL(:NEW.NRTELEFILISEP,'!')) OR
            (NVL(:OLD.NRRAMALFILI,'!') <> NVL(:NEW.NRRAMALFILI,'!')) OR
            (NVL(:OLD.NRDDDTELEXFILI,'!') <> NVL(:NEW.NRDDDTELEXFILI,'!')) OR
            (NVL(:OLD.NRTELEXFILISEP,'!') <> NVL(:NEW.NRTELEXFILISEP,'!')) OR
            (NVL(:OLD.NRRAMTELEXFILI,'!') <> NVL(:NEW.NRRAMTELEXFILI,'!')) OR
            (NVL(:OLD.DSEMAILEMXMLNFE,'!') <> NVL(:NEW.DSEMAILEMXMLNFE,'!')) THEN

            IF (NVL(:OLD.CDFILIAL,'!') <> NVL(:NEW.CDFILIAL,'!')) THEN
               V_DESC := V_DESC || ' CdFilial=' || :NEW.CDFILIAL;
            END IF;

            IF :NEW.IDTPENDEFILI IS NOT NULL THEN
               IF :NEW.IDTPENDEFILI = 'P' THEN
                  V_DSTPENDEFILI := '-Principal';
               ELSE
                  IF :NEW.IDTPENDEFILI = 'C' THEN
                     V_DSTPENDEFILI := '-Cobrana';
                  ELSE
                     IF :NEW.IDTPENDEFILI = 'E' THEN
                        V_DSTPENDEFILI := '-Exterior';
                     ELSE
                        IF :NEW.IDTPENDEFILI = 'X' THEN
                           V_DSTPENDEFILI := '-Exportao';
                        END IF;
                     END IF;
                  END IF;
               END IF;
               V_DESC :=   V_DESC||' TipoEnde='||:NEW.IDTPENDEFILI||V_DSTPENDEFILI;
            END IF;

            IF (NVL(:OLD.DSENDEFILISEP,'!') <> NVL(:NEW.DSENDEFILISEP,'!')) THEN
               V_DESC := V_DESC || ' DescEndereo=' || :NEW.DSENDEFILISEP;
            END IF;

            IF (NVL(:OLD.NRENDEFILISEP,'!') <> NVL(:NEW.NRENDEFILISEP,'!')) THEN
               V_DESC := V_DESC || ' Nmero=' || :NEW.NRENDEFILISEP;
            END IF;

            IF (NVL(:OLD.DSCOMPENDFIL,'!') <> NVL(:NEW.DSCOMPENDFIL,'!')) THEN
               V_DESC := V_DESC || ' Complemento=' || :NEW.DSCOMPENDFIL;
            END IF;

            IF (NVL(:OLD.CDLOGRADOURO,'!') <> NVL(:NEW.CDLOGRADOURO,'!')) THEN
               V_DESC := V_DESC || ' Logradouro=' || :NEW.CDLOGRADOURO;
            END IF;

            IF (NVL(:OLD.CDPAIS,'!') <> NVL(:NEW.CDPAIS,'!')) THEN
               V_DESC := V_DESC || ' Pas=' || :NEW.CDPAIS;
            END IF;

            IF (NVL(:OLD.SGESTADO,'!') <> NVL(:NEW.SGESTADO,'!')) THEN
               V_DESC := V_DESC || ' SgEstado=' || :NEW.SGESTADO;
            END IF;

            IF (NVL(:OLD.CDMUNICIPIO,'!') <> NVL(:NEW.CDMUNICIPIO,'!')) THEN
               V_DESC := V_DESC || ' CdMunicpio=' || :NEW.CDMUNICIPIO;
            END IF;

            IF (NVL(:OLD.NRCEPFILI,'!') <> NVL(:NEW.NRCEPFILI,'!')) THEN
               V_DESC := V_DESC || ' Cep=' || :NEW.NRCEPFILI;
            END IF;

            IF (NVL(:OLD.NMCONTFILI,'!') <> NVL(:NEW.NMCONTFILI,'!')) THEN
               V_DESC := V_DESC || ' Contato=' || :NEW.NMCONTFILI;
            END IF;

            IF (NVL(:OLD.DSEMAILFILI,'!') <> NVL(:NEW.DSEMAILFILI,'!')) THEN
               V_DESC := V_DESC || ' Email=' || :NEW.DSEMAILFILI;
            END IF;

            IF (NVL(:OLD.NRDDDFAXFILI,'!') <> NVL(:NEW.NRDDDFAXFILI,'!')) THEN
               V_DESC := V_DESC || ' DDDFax=' || :NEW.NRDDDFAXFILI;
            END IF;

            IF (NVL(:OLD.NRFAXFILISEP,'!') <> NVL(:NEW.NRFAXFILISEP,'!')) THEN
               V_DESC := V_DESC || ' TelFax=' || :NEW.NRFAXFILISEP;
            END IF;

            IF (NVL(:OLD.NRRAMALFAXFILI,'!') <> NVL(:NEW.NRRAMALFAXFILI,'!')) THEN
               V_DESC := V_DESC || ' RamalFax=' || :NEW.NRRAMALFAXFILI;
            END IF;

            IF (NVL(:OLD.NRDDDTELEFILI,'!') <> NVL(:NEW.NRDDDTELEFILI,'!')) THEN
               V_DESC := V_DESC || ' DDDTel1=' || :NEW.NRDDDTELEFILI;
            END IF;

            IF (NVL(:OLD.NRTELEFILISEP,'!') <> NVL(:NEW.NRTELEFILISEP,'!')) THEN
               V_DESC := V_DESC || ' Tel1=' || :NEW.NRTELEFILISEP;
            END IF;

            IF (NVL(:OLD.NRRAMALFILI,'!') <> NVL(:NEW.NRRAMALFILI,'!')) THEN
               V_DESC := V_DESC || ' RamalTel=' || :NEW.NRRAMALFILI;
            END IF;

            IF (NVL(:OLD.NRDDDTELEXFILI,'!') <> NVL(:NEW.NRDDDTELEXFILI,'!')) THEN
               V_DESC := V_DESC || ' DDDTel2=' || :NEW.NRDDDTELEXFILI;
            END IF;

            IF (NVL(:OLD.NRTELEXFILISEP,'!') <> NVL(:NEW.NRTELEXFILISEP,'!')) THEN
               V_DESC := V_DESC || ' Tel2=' || :NEW.NRTELEXFILISEP;
            END IF;

            IF (NVL(:OLD.NRRAMTELEXFILI,'!') <> NVL(:NEW.NRRAMTELEXFILI,'!')) THEN
               V_DESC := V_DESC || ' RamalTel2=' || :NEW.NRRAMTELEXFILI;
            END IF;

            IF (NVL(:OLD.DSEMAILEMXMLNFE,'!') <> NVL(:NEW.DSEMAILEMXMLNFE,'!')) THEN
               V_DESC := V_DESC || ' EmailNFe=' || :NEW.DSEMAILEMXMLNFE;
            END IF;

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL;
         END IF;
      ELSE
         IF (NVL(:OLD.CDFILIAL,'!') <> NVL(:NEW.CDFILIAL,'!')) THEN
            V_DESC := V_DESC || ' CdFilial=' || :NEW.CDFILIAL;
         END IF;

         IF :NEW.IDTPENDEFILI IS NOT NULL THEN
            IF :NEW.IDTPENDEFILI = 'P' THEN
               V_DSTPENDEFILI := '-Principal';
            ELSE
               IF :NEW.IDTPENDEFILI = 'C' THEN
                  V_DSTPENDEFILI := '-Cobrana';
               ELSE
                  IF :NEW.IDTPENDEFILI = 'E' THEN
                     V_DSTPENDEFILI := '-Exterior';
                  ELSE
                     IF :NEW.IDTPENDEFILI = 'X' THEN
                        V_DSTPENDEFILI := '-Exportao';
                     END IF;
                  END IF;
               END IF;
            END IF;
            V_DESC :=   V_DESC||' TipoEnde='||:NEW.IDTPENDEFILI||V_DSTPENDEFILI;
         END IF;

         IF (NVL(:OLD.DSENDEFILISEP,'!') <> NVL(:NEW.DSENDEFILISEP,'!')) THEN
            V_DESC := V_DESC || ' DescEndereo=' || :NEW.DSENDEFILISEP;
         END IF;

         IF (NVL(:OLD.NRENDEFILISEP,'!') <> NVL(:NEW.NRENDEFILISEP,'!')) THEN
            V_DESC := V_DESC || ' Nmero=' || :NEW.NRENDEFILISEP;
         END IF;

         IF (NVL(:OLD.DSCOMPENDFIL,'!') <> NVL(:NEW.DSCOMPENDFIL,'!')) THEN
            V_DESC := V_DESC || ' Complemento=' || :NEW.DSCOMPENDFIL;
         END IF;

         IF (NVL(:OLD.CDLOGRADOURO,'!') <> NVL(:NEW.CDLOGRADOURO,'!')) THEN
            V_DESC := V_DESC || ' Logradouro=' || :NEW.CDLOGRADOURO;
         END IF;

         IF (NVL(:OLD.CDPAIS,'!') <> NVL(:NEW.CDPAIS,'!')) THEN
            V_DESC := V_DESC || ' Pas=' || :NEW.CDPAIS;
         END IF;

         IF (NVL(:OLD.SGESTADO,'!') <> NVL(:NEW.SGESTADO,'!')) THEN
            V_DESC := V_DESC || ' SgEstado=' || :NEW.SGESTADO;
         END IF;

         IF (NVL(:OLD.CDMUNICIPIO,'!') <> NVL(:NEW.CDMUNICIPIO,'!')) THEN
            V_DESC := V_DESC || ' CdMunicpio=' || :NEW.CDMUNICIPIO;
         END IF;

         IF (NVL(:OLD.NRCEPFILI,'!') <> NVL(:NEW.NRCEPFILI,'!')) THEN
            V_DESC := V_DESC || ' Cep=' || :NEW.NRCEPFILI;
         END IF;

         IF (NVL(:OLD.NMCONTFILI,'!') <> NVL(:NEW.NMCONTFILI,'!')) THEN
            V_DESC := V_DESC || ' Contato=' || :NEW.NMCONTFILI;
         END IF;

         IF (NVL(:OLD.DSEMAILFILI,'!') <> NVL(:NEW.DSEMAILFILI,'!')) THEN
            V_DESC := V_DESC || ' Email=' || :NEW.DSEMAILFILI;
         END IF;

         IF (NVL(:OLD.NRDDDFAXFILI,'!') <> NVL(:NEW.NRDDDFAXFILI,'!')) THEN
            V_DESC := V_DESC || ' DDDFax=' || :NEW.NRDDDFAXFILI;
         END IF;

         IF (NVL(:OLD.NRFAXFILISEP,'!') <> NVL(:NEW.NRFAXFILISEP,'!')) THEN
            V_DESC := V_DESC || ' TelFax=' || :NEW.NRFAXFILISEP;
         END IF;

         IF (NVL(:OLD.NRRAMALFAXFILI,'!') <> NVL(:NEW.NRRAMALFAXFILI,'!')) THEN
            V_DESC := V_DESC || ' RamalFax=' || :NEW.NRRAMALFAXFILI;
         END IF;

         IF (NVL(:OLD.NRDDDTELEFILI,'!') <> NVL(:NEW.NRDDDTELEFILI,'!')) THEN
            V_DESC := V_DESC || ' DDDTel1=' || :NEW.NRDDDTELEFILI;
         END IF;

         IF (NVL(:OLD.NRTELEFILISEP,'!') <> NVL(:NEW.NRTELEFILISEP,'!')) THEN
            V_DESC := V_DESC || ' Tel1=' || :NEW.NRTELEFILISEP;
         END IF;

         IF (NVL(:OLD.NRRAMALFILI,'!') <> NVL(:NEW.NRRAMALFILI,'!')) THEN
            V_DESC := V_DESC || ' RamalTel=' || :NEW.NRRAMALFILI;
         END IF;

         IF (NVL(:OLD.NRDDDTELEXFILI,'!') <> NVL(:NEW.NRDDDTELEXFILI,'!')) THEN
            V_DESC := V_DESC || ' DDDTel2=' || :NEW.NRDDDTELEXFILI;
         END IF;

         IF (NVL(:OLD.NRTELEXFILISEP,'!') <> NVL(:NEW.NRTELEXFILISEP,'!')) THEN
            V_DESC := V_DESC || ' Tel2=' || :NEW.NRTELEXFILISEP;
         END IF;

         IF (NVL(:OLD.NRRAMTELEXFILI,'!') <> NVL(:NEW.NRRAMTELEXFILI,'!')) THEN
            V_DESC := V_DESC || ' RamalTel2=' || :NEW.NRRAMTELEXFILI;
         END IF;

         IF (NVL(:OLD.DSEMAILEMXMLNFE,'!') <> NVL(:NEW.DSEMAILEMXMLNFE,'!')) THEN
            V_DESC := V_DESC || ' EmailNFe=' || :NEW.DSEMAILEMXMLNFE;
         END IF;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 300);
   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
         VALUES
            ('ENDEFILI',    SYSDATE,        NVL(V_NMOPERADOR,' '), V_TIPO,         V_DESC,  V_ITPESQ,
             V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,        V_DSSERVMETHOD, V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_ENDEFILI','5.42.xxx'); END;
/
