/*Nome: 9801_CDPTRGS_LOG_CDP_PROCFABRICA.SQL

Criao:
   17/02/2009 - Henrique Guidi Lobato

 Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              PROCFABRICA, para verifio de erros
*/


IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_PROCFABRICA' AND
                TYPE   = 'TR'                  AND
                U.UID  = O.UID                 AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_PROCFABRICA
GO


CREATE TRIGGER LOG_CDP_PROCFABRICA
ON PROCFABRICA
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(500);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER        VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD      VARCHAR(4);
   DECLARE @V_CDPRODUTO_OLD     VARCHAR(10);
   DECLARE @V_CDPROCFABRIC_OLD  VARCHAR(10);
   DECLARE @V_DTVALPROFABR_OLD  DATETIME;
   DECLARE @V_CDOPERADOR_OLD    VARCHAR(12);
   DECLARE @V_IDPROFABPADR_OLD  VARCHAR(1);
   DECLARE @V_QTPADPROCFAB_OLD  double precision;
   DECLARE @V_QTLOTEFABDIA_OLD  double precision;
   DECLARE @V_IDTPPROPOPF_OLD   VARCHAR(1);
   DECLARE @V_IDTPARREDPF_OLD   VARCHAR(1);

   DECLARE @V_CDFILIAL_NEW      VARCHAR(4);
   DECLARE @V_CDPRODUTO_NEW     VARCHAR(10);
   DECLARE @V_CDPROCFABRIC_NEW  VARCHAR(10);
   DECLARE @V_DTVALPROFABR_NEW  DATETIME;
   DECLARE @V_CDOPERADOR_NEW    VARCHAR(12);
   DECLARE @V_IDPROFABPADR_NEW  VARCHAR(1);
   DECLARE @V_QTPADPROCFAB_NEW  double precision;
   DECLARE @V_QTLOTEFABDIA_NEW  double precision;
   DECLARE @V_IDTPPROPOPF_NEW   VARCHAR(1);
   DECLARE @V_IDTPARREDPF_NEW   VARCHAR(1);


/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDCLIEATIV = '';
   SET @V_NRINCREST  = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDFILIAL,
         CDPRODUTO,
         CDPROCFABRIC,
         DTVALPROFABR,
         CDOPERADOR,
         IDPROFABPADR,
         QTPADPROCFAB,
         QTLOTEFABDIA,
         IDTPPROPOPF,
         IDTPARREDPF,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.CDFILIAL,
         DELETED.CDPRODUTO,
         DELETED.CDPROCFABRIC,
         DELETED.DTVALPROFABR,
         DELETED.CDOPERADOR,
         DELETED.IDPROFABPADR,
         DELETED.QTPADPROCFAB,
         DELETED.QTLOTEFABDIA,
         DELETED.IDTPPROPOPF,
         DELETED.IDTPARREDPF,
         INSERTED.CDFILIAL,
         INSERTED.CDPRODUTO,
         INSERTED.CDPROCFABRIC,
         INSERTED.DTVALPROFABR,
         INSERTED.CDOPERADOR,
         INSERTED.IDPROFABPADR,
         INSERTED.QTPADPROCFAB,
         INSERTED.QTLOTEFABDIA,
         INSERTED.IDTPPROPOPF,
         INSERTED.IDTPARREDPF

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

      UNION ALL

      SELECT
        'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
	 CDFILIAL,
         CDPRODUTO,
	 CDPROCFABRIC,
	 DTVALPROFABR,
	 CDOPERADOR,
	 IDPROFABPADR,
	 QTPADPROCFAB,
	 QTLOTEFABDIA,
	 IDTPPROPOPF,
 	 IDTPARREDPF

     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

   				 @V_CDFILIAL_OLD,
				 @V_CDPRODUTO_OLD,
				 @V_CDPROCFABRIC_OLD,
				 @V_DTVALPROFABR_OLD,
				 @V_CDOPERADOR_OLD,
				 @V_IDPROFABPADR_OLD,
				 @V_QTPADPROCFAB_OLD,
                                 @V_QTLOTEFABDIA_OLD,
			         @V_IDTPPROPOPF_OLD,
				 @V_IDTPARREDPF_OLD,

				 @V_CDFILIAL_NEW,
				 @V_CDPRODUTO_NEW,
				 @V_CDPROCFABRIC_NEW,
                                 @V_DTVALPROFABR_NEW,
                                 @V_CDOPERADOR_NEW,
                                 @V_IDPROFABPADR_NEW,
                                 @V_QTPADPROCFAB_NEW,
                                 @V_QTLOTEFABDIA_NEW,
                                 @V_IDTPPROPOPF_NEW,
                                 @V_IDTPARREDPF_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_TRIGGER = 'I' BEGIN

            IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial= ' + @V_CDFILIAL_NEW + ' ';
            END;

            IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CdProd= ' + @V_CDPRODUTO_NEW + ' ';
            END;

            IF @V_CDPROCFABRIC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CdProcFabric= ' + @V_CDPROCFABRIC_NEW + ' ';
            END;

            IF @V_DTVALPROFABR_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'DataValProFabr= ' + ( CONVERT(CHAR, @V_DTVALPROFABR_NEW,103)) + ' ';
            END;

            IF @V_CDOPERADOR_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CdOperador= ' + @V_CDOPERADOR_NEW + ' ';
            END;

            IF @V_IDPROFABPADR_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Padrao= ' + @V_IDPROFABPADR_NEW + ' ';
            END;

            IF @V_QTPADPROCFAB_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'QtdePadProd= ' + RTRIM(CONVERT(CHAR, @V_QTPADPROCFAB_NEW)) + ' ';
            END;

            IF @V_QTLOTEFABDIA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lote/Dia= ' + RTRIM(CONVERT(CHAR, @V_QTLOTEFABDIA_NEW)) + ' ';
            END;

            IF @V_IDTPPROPOPF_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Proporcao= ' + @V_IDTPPROPOPF_NEW + ' ';
            END;

            IF @V_IDTPARREDPF_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Arredondar= ' + @V_IDTPARREDPF_NEW + ' ';
            END;

         SET @V_ITPESQ = @V_CDFILIAL_NEW + @V_CDPRODUTO_NEW + @V_CDPROCFABRIC_NEW;

         SET @V_IDTIPOOPER = '1';
      END
      ELSE BEGIN
         IF @V_ID_TRIGGER = 'U' BEGIN

            IF (@V_CDFILIAL_OLD <> @V_CDFILIAL_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'Filial= ' + @V_CDFILIAL_NEW + ' ';
            END;

            IF (@V_CDPRODUTO_OLD <> @V_CDPRODUTO_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'CdProd= ' + @V_CDPRODUTO_NEW + ' ';
            END;

            IF (@V_CDPROCFABRIC_OLD <> @V_CDPROCFABRIC_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'CdProcFabric= ' + @V_CDPROCFABRIC_NEW + ' ';
            END;

            IF (@V_DTVALPROFABR_OLD <> @V_DTVALPROFABR_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'DataValProFabr= ' + ( CONVERT(CHAR, @V_DTVALPROFABR_NEW,103)) + ' ';
            END;

            IF (@V_CDOPERADOR_OLD <> @V_CDOPERADOR_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'CdOperador= ' + @V_CDOPERADOR_NEW + ' ';
            END;

            IF (@V_IDPROFABPADR_OLD <> @V_IDPROFABPADR_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'Padrao= ' + @V_IDPROFABPADR_NEW + ' ';
            END;

            IF (@V_QTPADPROCFAB_OLD <> @V_QTPADPROCFAB_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'QtdePadProd= ' + RTRIM(CONVERT(CHAR, @V_QTPADPROCFAB_NEW)) + ' ';
            END;

            IF (@V_QTLOTEFABDIA_OLD <> @V_QTLOTEFABDIA_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'Lote/Dia= ' + RTRIM(CONVERT(CHAR, @V_QTLOTEFABDIA_NEW)) + ' ';
            END;

            IF (@V_IDTPPROPOPF_OLD <> @V_IDTPPROPOPF_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'Proporcao= ' + @V_IDTPPROPOPF_NEW + ' ';
            END;

            IF (@V_IDTPARREDPF_OLD <> @V_IDTPARREDPF_NEW) BEGIN
               SET @V_DESC = @V_DESC + 'Arredondar= ' + @V_IDTPARREDPF_NEW + ' ';
            END;

            SET @V_ITPESQ = @V_CDFILIAL_NEW + @V_CDPRODUTO_NEW + @V_CDPROCFABRIC_NEW;

            SET @V_IDTIPOOPER = '2';

         END;

      IF @V_ID_TRIGGER = 'D'  BEGIN

            IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial= ' + @V_CDFILIAL_OLD + ' ';
            END;

            IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CdProd= ' + @V_CDPRODUTO_OLD + ' ';
            END;

            IF @V_CDPROCFABRIC_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CdProcFabric= ' + @V_CDPROCFABRIC_OLD + ' ';
            END;

            IF @V_DTVALPROFABR_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'DataValProFabr= ' + ( CONVERT(CHAR, @V_DTVALPROFABR_OLD,103)) + ' ';
            END;

            IF @V_CDOPERADOR_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CdOperador= ' + @V_CDOPERADOR_OLD + ' ';
            END;

            IF @V_IDPROFABPADR_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Padrao= ' + @V_IDPROFABPADR_OLD + ' ';
            END;

            IF @V_QTPADPROCFAB_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'QtdePadProd= ' + RTRIM(CONVERT(CHAR, @V_QTPADPROCFAB_OLD)) + ' ';
            END;

            IF @V_QTLOTEFABDIA_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lote/Dia= ' + RTRIM(CONVERT(CHAR, @V_QTLOTEFABDIA_OLD)) + ' ';
            END;

            IF @V_IDTPPROPOPF_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Proporcao= ' + @V_IDTPPROPOPF_OLD + ' ';
            END;

            IF @V_IDTPARREDPF_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Arredondar= ' + @V_IDTPARREDPF_OLD + ' ';
            END;

         SET @V_ITPESQ = @V_CDFILIAL_OLD + @V_CDPRODUTO_OLD + @V_CDPROCFABRIC_OLD;

         SET @V_IDTIPOOPER = '3';
      END;
   END;

   IF NOT (@V_DESC IS NULL) BEGIN

      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER)
                  VALUES   ('PROCFABRICA', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                             @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                             @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                             @V_DSSERVMETHOD,   @V_DSREMOTEOPER);
   END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

   				 @V_CDFILIAL_OLD,
				 @V_CDPRODUTO_OLD,
				 @V_CDPROCFABRIC_OLD,
				 @V_DTVALPROFABR_OLD,
				 @V_CDOPERADOR_OLD,
				 @V_IDPROFABPADR_OLD,
				 @V_QTPADPROCFAB_OLD,
                                 @V_QTLOTEFABDIA_OLD,
			         @V_IDTPPROPOPF_OLD,
				 @V_IDTPARREDPF_OLD,

				 @V_CDFILIAL_NEW,
				 @V_CDPRODUTO_NEW,
				 @V_CDPROCFABRIC_NEW,
                                 @V_DTVALPROFABR_NEW,
                                 @V_CDOPERADOR_NEW,
                                 @V_IDPROFABPADR_NEW,
                                 @V_QTPADPROCFAB_NEW,
                                 @V_QTLOTEFABDIA_NEW,
                                 @V_IDTPPROPOPF_NEW,
                                 @V_IDTPARREDPF_NEW;

   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_PROCFABRICA','5.07.000';
GO
